require "X11/Display"

$d = X11::Display.new

$wsize = X11::Size[512,384]

$d = X11::Display.new
$s = $d.screens[0]
$dp = $s.depths.find {|dp| dp.depth > 1 }
$cmap = $s.default_colormap

$w = X11::Window.new($d)
$w.create_window($dp.depth, $s.root,
	X11::Rectangle[X11::Point[0,0], $wsize],
	4, :InputOutput, :CopyFromParent,
		X11::WindowAttributes.new(
			:background_pixel => $s.black_pixel))
$w.map
$gc = X11::Graphics.new($d)
$gc.create($w,X11::GraphicsInfo.new(
	:foreground => $s.white_pixel,
))
$g = X11::GraphicsOnDrawable[$w,$gc]
$white = $s.white_pixel
$black = $s.black_pixel
foo,$red = $cmap.alloc_color(X11::RGB["#ff0000"])

def $g.color=(colornum)
	$gc.change(X11::GraphicsInfo.new(:foreground => colornum))
end

#----------------------------------------------------------------#

def tone1(i,d=100)
	$d.change_keyboard_control(X11::KeyboardControl[:bell_pitch=>
		(55*2**(i/12.0)).to_i
	])
	$d.bell(0)
	$d.flush
#	sleep d/1000.0
end

a = 2.0
k = 0; n=10000
t = 0
while true
	kk = (1-(k.to_f/n)**2)**.5
	a=a*kk
	a=a*(60-a)/15
	tone1(a)
	$g.color = $black
	$g.draw_rectangles([X11::Rectangle[
		X11::Point[t,0],
		X11::Size[0,$wsize.y]]])
	$g.color = $white
	$g.draw_rectangles([X11::Rectangle[
		X11::Point[t,372-(a*6).to_i],
		X11::Size[0,5]]])
	$g.color = $red
	$g.draw_rectangles([X11::Rectangle[
		X11::Point[t,383-($wsize.y*kk).to_i],
		X11::Size[0,0]]])
	k+=1
	t+=1; t%=$wsize.x
end
