require "X11/Display"

X11::Display.class_eval {
  def play s
    @play_oct ||= 3
    @play_len ||= 4
    @play_tempo ||= 120
    s.downcase.scan(/([a-g][#\+\-]?)([0-9]*)(\.*)|([olt])([0-9]+)/) {|t|
#      p @play_oct, @play_len, @_play_tempo
      case $4
      when 'o'; @play_oct   = $5.to_i
      when 'l'; @play_len   = $5.to_i
      when 't'; @play_tempo = $5.to_i
      else
        note = "c d ef g a b".index($1[0..0])
        note += case $1[1] when ?+,?#; +1; when ?-; -1; else 0 end
        tone = 32.7 * 2**(@play_oct + note/12.0)
        dur = 240.0/@play_tempo/(if $2.length>0; $2.to_i else @play_len end)
        dur *= 2 - (2 ** -$3.length)
        change_keyboard_control(X11::KeyboardControl[
          :bell_pitch => tone.to_i,
          :bell_duration => (750*dur).to_i])
#        p tone,dur
	p $1
       bell 100; sock.flush; sleep dur
      end
    }
  end
}

d = X11::Display.new
d.play "t120l8o3"
#d.play "c4.c16c16cde-fd4o2b-4b-2"
#d.play "o3e-4l16e-fe-d-co2b-l8a-e-f4"
d.play "o3d-4cc16d-16co2b-4"
