# small test program
# algorithmic music generation
# using Display#change_keyboard_control and sleep()
# Copyright (c) 2001 by Mathieu Bouchard

require "X11/Display"
$d = X11::Display.new

def tone1(i,d=100)
	$d.change_keyboard_control(X11::KeyboardControl[
		:bell_pitch => (55*2**(i/12.0)).to_i
	])
	$d.bell(0)
	$d.flush
	sleep d/1000.0
end

def pat1(a,b,&c)
	[a,a+1,b,a+4,b+12,a+1,b].each(&c)
end

def pat2(a,&c)
	[[a,a],[a,a+1],[a+3,a+7],[a+3,a+3]].each(&c)
end

k=[2,2,4,2]
i=0
while true
	pat2(0) {|a,b|
		pat1(24+a,b) {|x|
			tone1 x,100*k[i]
			i+=1; i%=k.length
		}
	}
	# receive events
	$d.xreceive_many
	# discard events
	nil while $d.next_event
end
