# default values

require "X11/Display"

class WithDefaults<X11::Form; fields_are \
	[:id, Integer],
	[:name, String],
	[:pi, Float, {:default => 3.14159 }],
	[:qix, Object, {:default => nil}],
	[:qbert, Range, {:default => 1..5}]
end

foo = WithDefaults[42,"mappy"]
zut = proc {|v|
	t = v.type
	t.field_names.each {|fn|
		puts "#{fn}: #{v.send(fn).inspect}"
	}
}

zut[foo]
p foo
puts foo

